package kaysaar.aotd_question_of_loyalty.data.plugins;

import java.lang.invoke.MethodType;
import java.lang.reflect.InvocationTargetException;
import ashlib.data.plugins.reflection.ReflectionBetterUtilis;
import com.fs.starfarer.api.util.Pair;
import com.fs.starfarer.api.ui.UIComponentAPI;
import java.util.List;
import com.fs.starfarer.api.ui.UIPanelAPI;
import java.lang.reflect.Method;
import java.lang.reflect.Field;
import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;

public class ReflectionUtilis
{
    private static final Class<?> fieldClass;
    private static final MethodHandles.Lookup lookup;
    private static final MethodHandle setFieldHandle;
    private static final MethodHandle getFieldHandle;
    private static final MethodHandle getFieldNameHandle;
    private static final MethodHandle setFieldAccessibleHandle;
    private static final Class<?> methodClass;
    private static final MethodHandle getMethodNameHandle;
    private static final MethodHandle invokeMethodHandle;
    private static final MethodHandle setMethodAccessable;
    private static final MethodHandle getModifiersHandle;
    private static final MethodHandle getParameterTypesHandle;
    
    public static Object getPrivateVariable(final String fieldName, final Object instanceToGetFrom) {
        try {
            for (Class<?> instances = instanceToGetFrom.getClass(); instances != null; instances = instances.getSuperclass()) {
                for (final Object obj : instances.getDeclaredFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        return ReflectionUtilis.getFieldHandle.invoke(obj, instanceToGetFrom);
                    }
                }
                for (final Object obj : instances.getFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        return ReflectionUtilis.getFieldHandle.invoke(obj, instanceToGetFrom);
                    }
                }
            }
            return null;
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static Object getPrivateVariableFromSuperClass(final String fieldName, final Object instanceToGetFrom) {
        try {
            for (Class<?> instances = instanceToGetFrom.getClass(); instances != null; instances = instances.getSuperclass()) {
                for (final Object obj : instances.getDeclaredFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        return ReflectionUtilis.getFieldHandle.invoke(obj, instanceToGetFrom);
                    }
                }
                for (final Object obj : instances.getFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        return ReflectionUtilis.getFieldHandle.invoke(obj, instanceToGetFrom);
                    }
                }
            }
            return null;
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static void setPrivateVariableFromSuperclass(final String fieldName, final Object instanceToModify, final Object newValue) {
        try {
            for (Class<?> instances = instanceToModify.getClass(); instances != null; instances = instances.getSuperclass()) {
                for (final Object obj : instances.getDeclaredFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        ReflectionUtilis.setFieldHandle.invoke(obj, instanceToModify, newValue);
                        return;
                    }
                }
                for (final Object obj : instances.getFields()) {
                    ReflectionUtilis.setFieldAccessibleHandle.invoke(obj, true);
                    final String name = ReflectionUtilis.getFieldNameHandle.invoke(obj);
                    if (name.equals(fieldName)) {
                        ReflectionUtilis.setFieldHandle.invoke(obj, instanceToModify, newValue);
                        return;
                    }
                }
            }
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static boolean hasMethodOfName(final String name, final Object instance) {
        try {
            for (final Object method : instance.getClass().getMethods()) {
                if (ReflectionUtilis.getMethodNameHandle.invoke(method).equals(name)) {
                    return true;
                }
            }
            return false;
        }
        catch (final Throwable e) {
            return false;
        }
    }
    
    public static Object invokeMethod(final String methodName, final Object instance, final Object... arguments) {
        try {
            final Object method = instance.getClass().getMethod(methodName, (Class<?>[])new Class[0]);
            return ReflectionUtilis.invokeMethodHandle.invoke(method, instance, arguments);
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static Object invokeMethodDirectly(final Object method, final Object instance, final Object... arguments) {
        try {
            return ReflectionUtilis.invokeMethodHandle.invoke(method, (Void)null, arguments);
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static List<UIComponentAPI> getChildrenCopy(final UIPanelAPI panel) {
        try {
            return (List)invokeMethod("getChildrenCopy", panel, new Object[0]);
        }
        catch (final Throwable e) {
            return null;
        }
    }
    
    public static Pair<Object, Class<?>[]> getMethodFromSuperclass(final String methodName, final Object instance) {
        for (Class<?> currentClass = instance.getClass(); currentClass != null; currentClass = currentClass.getSuperclass()) {
            final Method[] declaredMethods;
            final Object[] methods = declaredMethods = currentClass.getDeclaredMethods();
            for (final Object method : declaredMethods) {
                try {
                    final MethodHandle getParameterTypesHandle = ReflectionBetterUtilis.getParameterTypesHandle((Class)method.getClass(), "getParameterTypes");
                    if (ReflectionUtilis.getMethodNameHandle.invoke(method).equals(methodName)) {
                        final Class<?>[] parameterTypes = getParameterTypesHandle.invoke(method);
                        return (Pair<Object, Class<?>[]>)new Pair(method, (Object)parameterTypes);
                    }
                }
                catch (final Throwable e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }
    
    public static Object invokeStaticMethodWithAutoProjection(final Class<?> targetClass, final String methodName, final Object... arguments) {
        try {
            final Object[] methods = targetClass.getDeclaredMethods();
            Object matchingMethod = null;
            Class<?>[] parameterTypes = null;
            for (final Object method : methods) {
                final String currentName = ReflectionUtilis.getMethodNameHandle.invoke(method);
                final int modifiers = ReflectionUtilis.getModifiersHandle.invoke(method);
                if (currentName.equals(methodName) && (modifiers & 0x8) != 0x0) {
                    parameterTypes = ReflectionUtilis.getParameterTypesHandle.invoke(method);
                    if (parameterTypes.length == arguments.length) {
                        matchingMethod = method;
                        break;
                    }
                }
            }
            if (matchingMethod == null) {
                throw new NoSuchMethodException("Static method " + methodName + " not found in class " + targetClass.getName());
            }
            final Object[] projectedArgs = new Object[parameterTypes.length];
            for (int i = 0; i < parameterTypes.length; ++i) {
                final Object arg = (arguments.length > i) ? arguments[i] : null;
                if (arg == null) {
                    if (parameterTypes[i].isPrimitive()) {
                        throw new IllegalArgumentException("Null cannot be used for primitive type: " + parameterTypes[i].getName());
                    }
                    projectedArgs[i] = null;
                }
                else {
                    projectedArgs[i] = convertArgument(arg, parameterTypes[i]);
                }
            }
            ReflectionUtilis.setMethodAccessable.invoke(matchingMethod, true);
            return ReflectionUtilis.invokeMethodHandle.invoke(matchingMethod, (Void)null, projectedArgs);
        }
        catch (final Throwable e) {
            if (e instanceof final InvocationTargetException ex) {
                final Throwable cause = ex.getTargetException();
                System.err.println("Root cause of InvocationTargetException: " + cause.getClass().getName());
                cause.printStackTrace();
            }
            else {
                e.printStackTrace();
            }
            throw new RuntimeException(e);
        }
    }
    
    public static Object invokeMethodWithAutoProjection(final String methodName, final Object instance, final Object... arguments) {
        final Pair<Object, Class<?>[]> methodPair = getMethodFromSuperclass(methodName, instance);
        if (methodPair == null) {
            try {
                throw new NoSuchMethodException("Method " + methodName + " not found in class hierarchy of " + instance.getClass().getName());
            }
            catch (final NoSuchMethodException e) {
                throw new RuntimeException(e);
            }
        }
        final Object method = methodPair.one;
        final Class<?>[] parameterTypes = (Class<?>[])methodPair.two;
        final Object[] projectedArgs = new Object[parameterTypes.length];
        for (int index = 0; index < parameterTypes.length; ++index) {
            final Object arg = (arguments.length > index) ? arguments[index] : null;
            if (arg == null) {
                if (parameterTypes[index].isPrimitive()) {
                    throw new IllegalArgumentException("Argument at index " + index + " cannot be null for primitive type " + parameterTypes[index].getName());
                }
                projectedArgs[index] = null;
            }
            else {
                try {
                    projectedArgs[index] = convertArgument(arg, parameterTypes[index]);
                }
                catch (final Exception e2) {
                    throw new IllegalArgumentException("Cannot convert argument at index " + index + " to " + parameterTypes[index].getName(), (Throwable)e2);
                }
            }
        }
        try {
            ReflectionUtilis.setMethodAccessable.invoke(method, true);
        }
        catch (final Throwable e3) {
            throw new RuntimeException(e3);
        }
        try {
            return ReflectionUtilis.invokeMethodHandle.invoke(method, instance, projectedArgs);
        }
        catch (final Throwable e3) {
            throw new RuntimeException(e3);
        }
    }
    
    public static Object convertArgument(final Object arg, final Class<?> targetType) {
        if (targetType.isAssignableFrom(arg.getClass())) {
            return arg;
        }
        if (!targetType.isPrimitive()) {
            return targetType.cast(arg);
        }
        if (targetType == Integer.TYPE) {
            return ((Number)arg).intValue();
        }
        if (targetType == Long.TYPE) {
            return ((Number)arg).longValue();
        }
        if (targetType == Double.TYPE) {
            return ((Number)arg).doubleValue();
        }
        if (targetType == Float.TYPE) {
            return ((Number)arg).floatValue();
        }
        if (targetType == Short.TYPE) {
            return ((Number)arg).shortValue();
        }
        if (targetType == Byte.TYPE) {
            return ((Number)arg).byteValue();
        }
        if (targetType == Boolean.TYPE) {
            return arg;
        }
        if (targetType == Character.TYPE) {
            return arg;
        }
        throw new IllegalArgumentException("Unsupported primitive type: " + targetType.getName());
    }
    
    public static Object invokeStaticMethod(final Class<?> targetClass, final String methodName, final Object... arguments) {
        try {
            final Class<?>[] parameterTypes = new Class[arguments.length];
            for (int i = 0; i < arguments.length; ++i) {
                parameterTypes[i] = arguments[i].getClass();
            }
            final Object method = findStaticMethodByParameterTypes(targetClass, parameterTypes);
            if (method == null) {
                throw new NoSuchMethodException("Static method " + methodName + " not found in class " + targetClass.getName());
            }
            return ReflectionUtilis.invokeMethodHandle.invoke(method, (Void)null, arguments);
        }
        catch (final Throwable e) {
            throw new RuntimeException(e);
        }
    }
    
    public static Object findStaticMethodByParameterTypes(final Class<?> targetClass, final Class<?>... parameterTypes) {
        try {
            for (Class<?> currentClass = targetClass; currentClass != null; currentClass = ReflectionUtilis.invokeMethodHandle.invoke((Class)currentClass, "getSuperclass")) {
                final Method[] declaredMethods;
                final Object[] methods = declaredMethods = currentClass.getDeclaredMethods();
                for (final Object method : declaredMethods) {
                    try {
                        final int modifiers = ReflectionUtilis.getModifiersHandle.invoke(method);
                        if ((modifiers & 0x8) != 0x0) {
                            final Class<?>[] methodParamTypes = ReflectionUtilis.getParameterTypesHandle.invoke(method);
                            if (areParameterTypesMatching(methodParamTypes, parameterTypes)) {
                                return method;
                            }
                        }
                    }
                    catch (final Throwable e) {
                        e.printStackTrace();
                    }
                }
            }
            return null;
        }
        catch (final Throwable e2) {
            throw new RuntimeException(e2);
        }
    }
    
    private static boolean areParameterTypesMatching(final Class<?>[] methodParamTypes, final Class<?>[] targetParamTypes) {
        if (methodParamTypes.length != targetParamTypes.length) {
            return false;
        }
        for (int i = 0; i < methodParamTypes.length; ++i) {
            if (!methodParamTypes[i].isAssignableFrom(targetParamTypes[i])) {
                return false;
            }
        }
        return true;
    }
    
    public static List<UIComponentAPI> getChildren(final UIPanelAPI panelAPI) {
        return getChildrenCopy(panelAPI);
    }
    
    static {
        lookup = MethodHandles.lookup();
        try {
            fieldClass = Class.forName("java.lang.reflect.Field", false, Class.class.getClassLoader());
            setFieldHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.fieldClass, "set", MethodType.methodType(Void.TYPE, Object.class, Object.class));
            getFieldHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.fieldClass, "get", MethodType.methodType(Object.class, Object.class));
            getFieldNameHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.fieldClass, "getName", MethodType.methodType(String.class));
            setFieldAccessibleHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.fieldClass, "setAccessible", MethodType.methodType(Void.TYPE, Boolean.TYPE));
            methodClass = Class.forName("java.lang.reflect.Method", false, Class.class.getClassLoader());
            getMethodNameHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.methodClass, "getName", MethodType.methodType(String.class));
            invokeMethodHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.methodClass, "invoke", MethodType.methodType(Object.class, Object.class, Object[].class));
            setMethodAccessable = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.methodClass, "setAccessible", MethodType.methodType(Void.TYPE, Boolean.TYPE));
            getModifiersHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.methodClass, "getModifiers", MethodType.methodType(Integer.TYPE));
            getParameterTypesHandle = ReflectionUtilis.lookup.findVirtual(ReflectionUtilis.methodClass, "getParameterTypes", MethodType.methodType(Class[].class));
        }
        catch (final Exception e) {
            throw new RuntimeException(e);
        }
    }
}
